net.sf.jasperreports.engine

## Class ElementDecorator

- java.lang.Object
- - net.sf.jasperreports.engine.ElementDecorator

- All Implemented Interfaces:
    java.lang.Cloneable, JRChild, JRCloneable, JRCommonElement, JRElement, JRIdentifiable, JRPropertiesHolder, JRStyleContainer, JRVisitable
  Direct Known Subclasses:
    TableSubreport

      public abstract class ElementDecorator
      extends java.lang.Object
      implements JRElement

  Version:
    $Id: ElementDecorator.java 5878 2013-01-07 20:23:13Z teodord $
  Author:
    Lucian Chirita (lucianc@users.sourceforge.net)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ElementDecorator(JRElement decorated)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `clone()`
    `java.lang.Object` | `clone(JRElementGroup parentGroup)`
    `JRElement` | `clone(JRElementGroup parentGroup, int y)`
    `void` | `collectExpressions(JRExpressionCollector collector)`
    `java.awt.Color` | `getBackcolor()`
    `JRDefaultStyleProvider` | `getDefaultStyleProvider()`
    `JRElementGroup` | `getElementGroup()` Indicates the logical group that the element belongs to.
    `java.awt.Color` | `getForecolor()`
    `int` | `getHeight()`
    `java.lang.String` | `getKey()` Returns the string value that uniquely identifies the element.
    `ModeEnum` | `getModeValue()` Returns the element transparency mode.
    `java.awt.Color` | `getOwnBackcolor()`
    `java.awt.Color` | `getOwnForecolor()`
    `ModeEnum` | `getOwnModeValue()`
    `JRPropertiesHolder` | `getParentProperties()` Returns the parent properties holder, whose properties are used as defaults for this object.
    `PositionTypeEnum` | `getPositionTypeValue()` Returns the position type for the element
    `JRExpression` | `getPrintWhenExpression()` Gets the expression that is evaluated in order to decide if the element should be displayed.
    `JRGroup` | `getPrintWhenGroupChanges()` Returns the group for which an element with a printRepeatedValues attribute set to true will be redisplayed even if the value has not changed.
    `JRPropertiesMap` | `getPropertiesMap()` Returns this object's properties map.
    `JRPropertyExpression[]` | `getPropertyExpressions()` Returns the list of dynamic/expression-based properties for this report element.
    `StretchTypeEnum` | `getStretchTypeValue()` Indicates the stretch type for the element
    `JRStyle` | `getStyle()` Returns this object's style.
    `java.lang.String` | `getStyleNameReference()` Returns the name of an external style which is to be used by this object.
    `java.util.UUID` | `getUUID()`
    `int` | `getWidth()`
    `int` | `getX()` Gets the the section relative horizontal offset of the element top left corner.
    `int` | `getY()` Gets the the section relative vertical offset of the element top left corner.
    `boolean` | `hasProperties()` Checks whether the object has any properties.
    `boolean` | `isPrintInFirstWholeBand()` Returns true if an element with a printRepeatedValues attribute set to true will be redisplayed for every new page or column that is not an overflow from a previous page or column.
    `boolean` | `isPrintRepeatedValues()` Specifies if the element value will be printed for every iteration, even if its value has not changed.
    `boolean` | `isPrintWhenDetailOverflows()` If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page.
    `boolean` | `isRemoveLineWhenBlank()` Returns true if the remaining blank space appearing when the value is not printed will be removed.
    `void` | `setBackcolor(java.awt.Color backcolor)`
    `void` | `setForecolor(java.awt.Color forecolor)`
    `void` | `setMode(byte mode)` Deprecated.
    `void` | `setMode(java.lang.Byte mode)` Deprecated.
    `void` | `setMode(ModeEnum mode)` Sets the element transparency mode.
    `void` | `setPositionType(byte positionType)` Deprecated.
    `void` | `setPositionType(PositionTypeEnum positionType)` Sets the position type for the element.
    `void` | `setPrintInFirstWholeBand(boolean isPrintInFirstWholeBand)` Specifies whether an element with a printRepeatedValues attribute set to true should be redisplayed for every new page or column that is not an overflow from a previous page or column.
    `void` | `setPrintRepeatedValues(boolean isPrintRepeatedValues)`
    `void` | `setPrintWhenDetailOverflows(boolean isPrintWhenDetailOverflows)` If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page.
    `void` | `setRemoveLineWhenBlank(boolean isRemoveLineWhenBlank)` Specifies whether the remaining blank space appearing when the value is not printed will be removed.
    `void` | `setStretchType(byte stretchType)` Deprecated.
    `void` | `setStretchType(StretchTypeEnum stretchTypeEnum)` Specifies how the engine should treat a missing image.
    `void` | `setWidth(int width)`
    `void` | `setX(int x)` Sets the the section relative horizontal offset of the element top left corner.
    `void` | `visit(JRVisitor visitor)`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ElementDecorator

          public ElementDecorator(JRElement decorated)

  - ### Method Detail

    - #### clone

          public java.lang.Object clone()

      Specified by:
        `clone` in interface `JRCloneable`
      Overrides:
        `clone` in class `java.lang.Object`

    - #### collectExpressions

          public void collectExpressions(JRExpressionCollector collector)

      Specified by:
        `collectExpressions` in interface `JRElement`

    - #### getElementGroup

          public JRElementGroup getElementGroup()

      Description copied from interface: `JRElement`
      Indicates the logical group that the element belongs to. More elements can be grouped in order to get the height of the tallest one.
      Specified by:
        `getElementGroup` in interface `JRElement`
      See Also:
        `StretchTypeEnum.RELATIVE_TO_TALLEST_OBJECT`

    - #### getUUID

          public java.util.UUID getUUID()

      Specified by:
        `getUUID` in interface `JRIdentifiable`

    - #### getKey

          public java.lang.String getKey()

      Description copied from interface: `JRElement`
      Returns the string value that uniquely identifies the element.
      Specified by:
        `getKey` in interface `JRCommonElement`
      Specified by:
        `getKey` in interface `JRElement`

    - #### getPositionTypeValue

          public PositionTypeEnum getPositionTypeValue()

      Description copied from interface: `JRElement`
      Returns the position type for the element
      Specified by:
        `getPositionTypeValue` in interface `JRElement`
      Returns:
        the position type

    - #### getPrintWhenExpression

          public JRExpression getPrintWhenExpression()

      Description copied from interface: `JRElement`
      Gets the expression that is evaluated in order to decide if the element should be displayed. This expression always returns a boolean value.
      Specified by:
        `getPrintWhenExpression` in interface `JRElement`

    - #### getPrintWhenGroupChanges

          public JRGroup getPrintWhenGroupChanges()

      Description copied from interface: `JRElement`
      Returns the group for which an element with a printRepeatedValues attribute set to true will be redisplayed even if the value has not changed.
      Specified by:
        `getPrintWhenGroupChanges` in interface `JRElement`
      See Also:
        `JRElement.isPrintRepeatedValues()`

    - #### getPropertyExpressions

          public JRPropertyExpression[] getPropertyExpressions()

      Description copied from interface: `JRElement`
      Returns the list of dynamic/expression-based properties for this report element.
      Specified by:
        `getPropertyExpressions` in interface `JRElement`
      Returns:
        an array containing the expression-based properties of this report element

    - #### getStretchTypeValue

          public StretchTypeEnum getStretchTypeValue()

      Description copied from interface: `JRElement`
      Indicates the stretch type for the element
      Specified by:
        `getStretchTypeValue` in interface `JRElement`
      Returns:
        a value representing one of the stretch type constants in `StretchTypeEnum`

    - #### getX

          public int getX()

      Description copied from interface: `JRElement`
      Gets the the section relative horizontal offset of the element top left corner.
      Specified by:
        `getX` in interface `JRElement`

    - #### getY

          public int getY()

      Description copied from interface: `JRElement`
      Gets the the section relative vertical offset of the element top left corner.
      Specified by:
        `getY` in interface `JRElement`

    - #### isPrintInFirstWholeBand

          public boolean isPrintInFirstWholeBand()

      Description copied from interface: `JRElement`
      Returns true if an element with a printRepeatedValues attribute set to true will be redisplayed for every new page or column that is not an overflow from a previous page or column.
      Specified by:
        `isPrintInFirstWholeBand` in interface `JRElement`
      See Also:
        `JRElement.isPrintRepeatedValues()`

    - #### isPrintRepeatedValues

          public boolean isPrintRepeatedValues()

      Description copied from interface: `JRElement`
      Specifies if the element value will be printed for every iteration, even if its value has not changed.
      Specified by:
        `isPrintRepeatedValues` in interface `JRElement`
      See Also:
        `JRElement.isRemoveLineWhenBlank()`, `JRElement.isPrintInFirstWholeBand()`

    - #### isPrintWhenDetailOverflows

          public boolean isPrintWhenDetailOverflows()

      Description copied from interface: `JRElement`
      If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page. Actually if there is at least one element with this attribute, the band is redisplayed from the beginning, except those elements that fitted in the current page and have isPrintWhenDetailOverflow set to false.
      Specified by:
        `isPrintWhenDetailOverflows` in interface `JRElement`

    - #### isRemoveLineWhenBlank

          public boolean isRemoveLineWhenBlank()

      Description copied from interface: `JRElement`
      Returns true if the remaining blank space appearing when the value is not printed will be removed. Under certain circumstances (the element has an empty string as its value or contains a repeated value that is supressed) the space reserved for the current element remains empty. If this method returns true, it means the engine will try to suppress the blank line, but will only succeed if no other elements occupy the same vertical space.
      Specified by:
        `isRemoveLineWhenBlank` in interface `JRElement`

    - #### setPositionType

          @Deprecated
          public void setPositionType(byte positionType)

      Deprecated.

    - #### setPositionType

          public void setPositionType(PositionTypeEnum positionType)

      Description copied from interface: `JRElement`
      Sets the position type for the element.
      Specified by:
        `setPositionType` in interface `JRElement`
      Parameters:
        `positionType` - the position type

    - #### setPrintInFirstWholeBand

          public void setPrintInFirstWholeBand(boolean isPrintInFirstWholeBand)

      Description copied from interface: `JRElement`
      Specifies whether an element with a printRepeatedValues attribute set to true should be redisplayed for every new page or column that is not an overflow from a previous page or column.
      Specified by:
        `setPrintInFirstWholeBand` in interface `JRElement`
      See Also:
        `JRElement.isPrintRepeatedValues()`

    - #### setPrintRepeatedValues

          public void setPrintRepeatedValues(boolean isPrintRepeatedValues)

      Specified by:
        `setPrintRepeatedValues` in interface `JRElement`

    - #### setPrintWhenDetailOverflows

          public void setPrintWhenDetailOverflows(boolean isPrintWhenDetailOverflows)

      Description copied from interface: `JRElement`
      If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page. Actually if there is at least one element with this attribute, the band is redisplayed from the beginning, except those elements that fitted in the current page and have isPrintWhenDetailOverflow set to false.
      Specified by:
        `setPrintWhenDetailOverflows` in interface `JRElement`

    - #### setRemoveLineWhenBlank

          public void setRemoveLineWhenBlank(boolean isRemoveLineWhenBlank)

      Description copied from interface: `JRElement`
      Specifies whether the remaining blank space appearing when the value is not printed will be removed. Under certain circumstances (the element has an empty string as its value or contains a repeated value that is supressed) the space reserved for the current element remains empty. If the parameter is set to true, it means the engine will try to suppress the blank line, but will only succeed if no other elements occupy the same vertical space.
      Specified by:
        `setRemoveLineWhenBlank` in interface `JRElement`

    - #### setStretchType

          @Deprecated
          public void setStretchType(byte stretchType)

      Deprecated.

    - #### setStretchType

          public void setStretchType(StretchTypeEnum stretchTypeEnum)

      Description copied from interface: `JRElement`
      Specifies how the engine should treat a missing image.
      Specified by:
        `setStretchType` in interface `JRElement`
      Parameters:
        `stretchTypeEnum` - a value representing one of the stretch type constants in `StretchTypeEnum`

    - #### setWidth

          public void setWidth(int width)

      Specified by:
        `setWidth` in interface `JRElement`

    - #### setX

          public void setX(int x)

      Description copied from interface: `JRElement`
      Sets the the section relative horizontal offset of the element top left corner.
      Specified by:
        `setX` in interface `JRElement`

    - #### clone

          public java.lang.Object clone(JRElementGroup parentGroup)

      Specified by:
        `clone` in interface `JRChild`

    - #### clone

          public JRElement clone(JRElementGroup parentGroup,
                        int y)

      Specified by:
        `clone` in interface `JRElement`

    - #### visit

          public void visit(JRVisitor visitor)

      Specified by:
        `visit` in interface `JRVisitable`

    - #### getBackcolor

          public java.awt.Color getBackcolor()

      Specified by:
        `getBackcolor` in interface `JRCommonElement`

    - #### getForecolor

          public java.awt.Color getForecolor()

      Specified by:
        `getForecolor` in interface `JRCommonElement`

    - #### getHeight

          public int getHeight()

      Specified by:
        `getHeight` in interface `JRCommonElement`

    - #### getModeValue

          public ModeEnum getModeValue()

      Description copied from interface: `JRCommonElement`
      Returns the element transparency mode. The default value depends on the type of the report element. Graphic elements like rectangles and lines are opaque by default, but the images are transparent. Both static texts and text fields are transparent by default, and so are the subreport elements.
      Specified by:
        `getModeValue` in interface `JRCommonElement`

    - #### getOwnBackcolor

          public java.awt.Color getOwnBackcolor()

      Specified by:
        `getOwnBackcolor` in interface `JRCommonElement`

    - #### getOwnForecolor

          public java.awt.Color getOwnForecolor()

      Specified by:
        `getOwnForecolor` in interface `JRCommonElement`

    - #### getOwnModeValue

          public ModeEnum getOwnModeValue()

      Specified by:
        `getOwnModeValue` in interface `JRCommonElement`

    - #### getWidth

          public int getWidth()

      Specified by:
        `getWidth` in interface `JRCommonElement`

    - #### setBackcolor

          public void setBackcolor(java.awt.Color backcolor)

      Specified by:
        `setBackcolor` in interface `JRCommonElement`

    - #### setForecolor

          public void setForecolor(java.awt.Color forecolor)

      Specified by:
        `setForecolor` in interface `JRCommonElement`

    - #### setMode

          @Deprecated
          public void setMode(byte mode)

      Deprecated.

    - #### setMode

          @Deprecated
          public void setMode(java.lang.Byte mode)

      Deprecated.

    - #### setMode

          public void setMode(ModeEnum mode)

      Description copied from interface: `JRCommonElement`
      Sets the element transparency mode.
      Specified by:
        `setMode` in interface `JRCommonElement`

    - #### getDefaultStyleProvider

          public JRDefaultStyleProvider getDefaultStyleProvider()

      Specified by:
        `getDefaultStyleProvider` in interface `JRStyleContainer`

    - #### getStyle

          public JRStyle getStyle()

      Description copied from interface: `JRStyleContainer`
      Returns this object's style.
      Specified by:
        `getStyle` in interface `JRStyleContainer`
      Returns:
        this object's style

    - #### getStyleNameReference

          public java.lang.String getStyleNameReference()

      Description copied from interface: `JRStyleContainer`
      Returns the name of an external style which is to be used by this object.

      External styles are defined in `templates` and are resolved at fill time. This attribute is only effective if no direct style (as returned by `getStyle()` is specified for this object.
      Specified by:
        `getStyleNameReference` in interface `JRStyleContainer`
      Returns:
        the name of an external style

    - #### getParentProperties

          public JRPropertiesHolder getParentProperties()

      Description copied from interface: `JRPropertiesHolder`
      Returns the parent properties holder, whose properties are used as defaults for this object.
      Specified by:
        `getParentProperties` in interface `JRPropertiesHolder`
      Returns:
        the parent properties holder, or `null` if no parent

    - #### getPropertiesMap

          public JRPropertiesMap getPropertiesMap()

      Description copied from interface: `JRPropertiesHolder`
      Returns this object's properties map.
      Specified by:
        `getPropertiesMap` in interface `JRPropertiesHolder`
      Returns:
        this object's properties map

    - #### hasProperties

          public boolean hasProperties()

      Description copied from interface: `JRPropertiesHolder`
      Checks whether the object has any properties.
      Specified by:
        `hasProperties` in interface `JRPropertiesHolder`
      Returns:
        whether the object has any properties

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com